PPUMASK = $2001
PPUADDR = $2006
PPUDATA = $2007

.PATCH 00:A916
  .data $0F, $26, $38, $2A ; new palette entry for logo (last color is also used for text)


; patch in hijacks
.PATCH 00:8553
  .data continue_title_anim

.PATCH 00:A831
  JSR rewrite_attributes

.PATCH 00:A83C
  JMP write_logo

.PATCH 00:A862
reentry:
  LDX #$20 ; set expected value


; rewrite Taito copyright text
.PATCH 00:A89B
  LDA #$48 ; ppu low byte (text start address)

.PATCH 00:A8E8
  .data $2C, $30, $1D, $0A, $12, $1D, $18, $30, $01, $09, $08, $05 ; (c) Taito 1985
  .data $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF ; unused space


; modify title invader animation
.PATCH 00:A8D8
  .byte $1C ; change 'P' of "1 Player" to 'S'

.PATCH 00:A97C
  LDA #$7C ; invader y position

.PATCH 00:A998
  CMP #$60 ; invader x destination

.PATCH 00:A99C
  LDA #$84 ; shot y position

.PATCH 00:A9AB
  LDA #$63 ; shot x position

.PATCH 00:A9CD
  CMP #$8D ; shot y destination

.PATCH 00:A9D6
  LDA #$22 ; target tile ppu address high ('P' in "1 Player")

.PATCH 00:A9DA
  LDA #$4C ; target tile ppu address lo

.PATCH 00:A9DE
  LDA #$19 ; target tile replacement id ('P')


; modify score screen
.PATCH 00:AA74
  LDA #$87 ; score table text ppu address lo

.PATCH 00:AA80
  CPX #$1C ; score table text length + 11

.PATCH 00:ABB0
  .data $1C, $0C, $18, $1B, $0E, $30, $1D, $0A, $0B, $15, $0E ; "Score Table" text
  .data $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF      ; unused space

.PATCH 00:ABC5
  .data $78, $46, $01, $2C ; change x position of each invader (last byte in each row)
  .data $78, $46, $41, $34
  .data $88, $60, $03, $30
  .data $98, $66, $03, $30
  .data $A8, $67, $00, $30


; new data for logo
.PATCH 00:AEF0
logo_nametable:
  .data $20, $E8, $A1, $A2, $A3, $A4, $A5, $A6, $A7, $A8, $A9, $AA, $AB, $AC, $00
  .data $21, $08, $AD, $AE, $AF, $B0, $B1, $B2, $B3, $B4, $B5, $B6, $B0, $B7, $00
  .data $21, $28, $B8, $B9, $BA, $BB, $BC, $BD, $BE, $BF, $C0, $C1, $C2, $C3, $00
  .data $21, $49, $C4, $C5, $C6, $C7, $C8, $C9, $CA, $CB, $CC, $CD, $00
  .data $21, $65, $CE, $CF, $D0, $D1, $D2, $D3, $D4, $D5, $D6, $D7, $D8, $D9, $DA, $DB, $DC, $DD, $DE, $DF, $00
  .data $21, $85, $E0, $E1, $E2, $E3, $E4, $E5, $E6, $E7, $E8, $E9, $EA, $EB, $EC, $ED, $EE, $EF, $F0, $F1, $00
  .data $21, $A5, $F2, $F3, $F4, $F5, $F6, $F7, $F8, $F9, $FA, $FB, $FC, $FD, $FE, $FF, $47, $48, $49, $4A, $00
  .data $21, $C6, $4B, $4C, $4D, $4E, $57, $58, $59, $5A, $5B, $5C, $5D, $5E, $67, $68, $69, $6A, $00

title_attributes:
  .data $AA, $AA, $AA, $AA, $AA, $AA, $AA, $AA
  .data $FF, $FF, $FF, $FF, $FF, $FF, $AA, $AA
  .data $FF, $FF, $FF, $FF, $FF, $FF, $AA, $AA
  .data $FF, $FF, $FF, $FF, $FF, $FF, $AA, $AA
  .data $AA, $AA, $AA, $AA, $AA, $AA, $AA, $AA
  .data $AA, $AA, $AA, $AA, $AA, $AA, $AA, $AA
  .data $55, $55, $55, $55, $55, $55, $00, $00
  .data $AA, $AA, $AA, $AA, $AA, $AA, $AA, $AA

; new code to write above data
write_logo:
  LDX #$FF
  set_addr:
    CPX #$8B
    BEQ done
    INX
    LDA logo_nametable,X
    STA PPUADDR
    INX
    LDA logo_nametable,X
    STA PPUADDR
    logo_data_loop:
      INX
      LDA logo_nametable,X
      BEQ set_addr
      STA PPUDATA
    BNE logo_data_loop
  done:
    JMP reentry

rewrite_attributes:
  LDA #$00
  STA PPUMASK
  LDA #$23
  JSR $AEA3
  STA PPUADDR
  LDA #$C0
  STA PPUADDR
  LDX #$00
  attr_data_loop:
    LDA title_attributes,X
    STA PPUDATA
    INX
    CPX #$40
  BCC attr_data_loop
  JMP $8723


; continue the invader animation on the title screen
continue_title_anim:
  LDA $20          ; add a slight delay
  CMP #$9D
  BCC ++
    LDA $737       ; check if the sprite is close to the right edge
    CMP #$C0
    BCC +
      LDA #$F0     ; hide off screen if so
      STA $734
      JMP ++
    +
    INC $737       ; otherwise keep moving to the right
    JMP $A9B8      ; animate sprite
  ++
  JMP $856B


.PATCH $5010
  .incbin "invaders_title.chr"
